#pragma once

#include <windows.h>

#define FTEXPORT extern "C" __declspec (dllexport)

typedef void (CALLBACK* FTWRITEDATACALLBACK)(LPVOID lpParam,LPCVOID lpData, DWORD nLen);

/*!	
	Video Codec Enumeration
**/

#define FT_VIDEOCODEC_SCREENVIDEO	0x03

/*!	
	Audio Codec Enumeration
**/

#define FT_SOUNDFORMAT_UNCOMPRESSED	0x00

#define FT_SOUNDRATE_5KHZ			0x00
#define FT_SOUNDRATE_11KHZ			0x01
#define FT_SOUNDRATE_22KHZ			0x02
#define FT_SOUNDRATE_44KHZ			0x03

#define FT_SOUNDSIZE_8BIT			0x00
#define FT_SOUNDSIZE_16BIT			0x01

#define FT_SOUNDTYPE_MONO			0x00
#define FT_SOUNDTYPE_STEREO			0x01

/*!	
	FTVIDEOINFO structure
**/

typedef struct tagFTVIDEOINFO
{
	DWORD dwCodec;
	DWORD dwWidth;
	DWORD dwHeight;
} FTVIDEOINFO;

/*!	
	FTAUDIOINFO structure
**/

typedef struct tagFTAUDIOINFO
{
	DWORD dwFormat;
	DWORD dwRate;
	DWORD dwSize;
	DWORD dwType;
} FTAUDIOINFO;

/*!
	FLV Stream interface.
**/

typedef struct HFTFLVSTREAM__ { int unused; } *HFTFLVSTREAM;

typedef struct tagFTFLVSTREAMINFO
{
	FTVIDEOINFO* lpVideoInfo;
	FTAUDIOINFO* lpAudioInfo;
	FTWRITEDATACALLBACK lpWriteDataCallback;
	LPVOID lpParam;
} FTFLVSTREAMINFO;

///	Create FLV stream
FTEXPORT HFTFLVSTREAM ftFlvStreamCreate(CONST FTFLVSTREAMINFO* lpFlvStreamInfo);

///	Destroy FLV stream
FTEXPORT void ftFlvStreamDestroy(HFTFLVSTREAM hFlvStream);

///	Add video tag to FLV stream
FTEXPORT void ftFlvStreamPutVideoData(HFTFLVSTREAM hFlvStream, LPCVOID lpData, DWORD nLen,DWORD nTimeStamp);

///	Add audio tag to FLV stream
FTEXPORT void ftFlvStreamPutAudioData(HFTFLVSTREAM hFlvStream, LPCVOID lpData, DWORD nLen,DWORD nTimeStamp);

///	Set context secure key
FTEXPORT void ftSetContextKey(const char* szKey);

/*!
	ScreenVideo encoder interface.
**/

typedef struct HFTSCREENVIDEOENCODER__ { int unused; } *HFTSCREENVIDEOENCODER;

///	Create ScreenVideo encoder
FTEXPORT HFTSCREENVIDEOENCODER ftScreenVideoEncoderCreate(DWORD dwWidth, DWORD dwHeight, DWORD dwBlockSize);

///	Destroy FLV stream
FTEXPORT void ftScreenVideoEncoderDestroy(HFTSCREENVIDEOENCODER hScreenVideoEncoder);

///	Encode row video frame to ScreenVideo frame
FTEXPORT BOOL ftScreenVideoEncodeFrame(HFTSCREENVIDEOENCODER hScreenVideoEncoder, LPCVOID lpData, DWORD cbBytes, BOOL bFlipY);

///	Get current encoded frame data
FTEXPORT void ftScreenVideoGetEncodedFrame(HFTSCREENVIDEOENCODER hScreenVideoEncoder, LPCVOID* lppData, LPDWORD lpcbBytes);

